Custom Templates
Generated on 18 Mar 2026
https://api.paperspace.com/v1
Endpoints
GET List templates
/custom-templates
Authorizations:
BearerAuth
An API key or access token
Fetches a list of templates.
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:dtCreatedorder
optional
The order to sort the results by.
Default:descname
optional
machineId
optional
Request: /custom-templates
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/custom-templates"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
agentType
required
The type of agent installed on the template.
availableMachineTypes
required
The machine types the template is available on.
Show child properties
isAvailable
required
Whether the template is available on this machine type.
machineTypeLabel
required
The label of the machine type.
defaultSizeGb
required
The default size of the template in gigabytes.
dtCreated
required
The date the template was created.
dtDeleted
optional Nullable
The date the shared drive was deleted.
id
required
The ID of the template.
name
required
The name of the template.
operatingSystemLabel
required
The operating system installed on the template.
parentMachineId
required
The ID of the parent machine.
region
required
The region the template is in.
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"agentType": "string",
"availableMachineTypes": [],
"defaultSizeGb": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"id": "string",
"name": "string",
"operatingSystemLabel": "string",
"parentMachineId": "string",
"region": "ny2"
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}POST Create template
/custom-templates
Authorizations:
BearerAuth
An API key or access token
Create a template for a machine.
Request Body: application/json
machineId
required
The ID of the machine to create a template from.
name
required
The name of the template.
Request: /custom-templates
{
"machineId": "string",
"name": "string"
}curl -X POST \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
-d '{
"machineId": "string",
"name": "string"
}' \
"https://api.paperspace.com/v1/custom-templates"Responses
200
Successful response
application/json
data
required
The template.
Show child properties
agentType
required
The type of agent installed on the template.
availableMachineTypes
required
The machine types the template is available on.
Show child properties
isAvailable
required
Whether the template is available on this machine type.
machineTypeLabel
required
The label of the machine type.
defaultSizeGb
required
The default size of the template in gigabytes.
dtCreated
required
The date the template was created.
dtDeleted
optional Nullable
The date the shared drive was deleted.
id
required
The ID of the template.
name
required
The name of the template.
operatingSystemLabel
required
The operating system installed on the template.
parentMachineId
required
The ID of the parent machine.
region
required
The region the template is in.
event
required
The machine event to poll for the async operation.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"data": {
"agentType": "string",
"availableMachineTypes": [],
"defaultSizeGb": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"id": "string",
"name": "string",
"operatingSystemLabel": "string",
"parentMachineId": "string",
"region": "ny2"
},
"event": {
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
}{
"code": "string",
"message": "string"
}GET Get a template
/custom-templates/{id}
Authorizations:
BearerAuth
An API key or access token
Fetches a single template by ID.
Path Parameters
id
required
The ID of the template to fetch.
Request: /custom-templates/{id}
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/custom-templates/{id}"Responses
200
Successful response
application/json
agentType
required
The type of agent installed on the template.
availableMachineTypes
required
The machine types the template is available on.
Show child properties
isAvailable
required
Whether the template is available on this machine type.
machineTypeLabel
required
The label of the machine type.
defaultSizeGb
required
The default size of the template in gigabytes.
dtCreated
required
The date the template was created.
dtDeleted
optional Nullable
The date the shared drive was deleted.
id
required
The ID of the template.
name
required
The name of the template.
operatingSystemLabel
required
The operating system installed on the template.
parentMachineId
required
The ID of the parent machine.
region
required
The region the template is in.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"agentType": "string",
"availableMachineTypes": [
{
"isAvailable": true,
"machineTypeLabel": "string"
}
],
"defaultSizeGb": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"id": "string",
"name": "string",
"operatingSystemLabel": "string",
"parentMachineId": "string",
"region": "ny2"
}{
"code": "string",
"message": "string"
}PUT Update a template
/custom-templates/{id}
Authorizations:
BearerAuth
An API key or access token
Updates a single template by ID.
Path Parameters
id
required
The ID of the template to update.
Request Body: application/json
name
required
The name of the template.
Request: /custom-templates/{id}
{
"name": "string"
}curl -X PUT \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
-d '{
"name": "string"
}' \
"https://api.paperspace.com/v1/custom-templates/{id}"Responses
200
Successful response
application/json
agentType
required
The type of agent installed on the template.
availableMachineTypes
required
The machine types the template is available on.
Show child properties
isAvailable
required
Whether the template is available on this machine type.
machineTypeLabel
required
The label of the machine type.
defaultSizeGb
required
The default size of the template in gigabytes.
dtCreated
required
The date the template was created.
dtDeleted
optional Nullable
The date the shared drive was deleted.
id
required
The ID of the template.
name
required
The name of the template.
operatingSystemLabel
required
The operating system installed on the template.
parentMachineId
required
The ID of the parent machine.
region
required
The region the template is in.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"agentType": "string",
"availableMachineTypes": [
{
"isAvailable": true,
"machineTypeLabel": "string"
}
],
"defaultSizeGb": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"id": "string",
"name": "string",
"operatingSystemLabel": "string",
"parentMachineId": "string",
"region": "ny2"
}{
"code": "string",
"message": "string"
}DELETE Delete template
/custom-templates/{id}
Authorizations:
BearerAuth
An API key or access token
Delete a template.
Path Parameters
id
required
The ID of the template to delete.
Request: /custom-templates/{id}
curl -X DELETE \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/custom-templates/{id}"Responses
200
Successful response
application/json
agentType
required
The type of agent installed on the template.
availableMachineTypes
required
The machine types the template is available on.
Show child properties
isAvailable
required
Whether the template is available on this machine type.
machineTypeLabel
required
The label of the machine type.
defaultSizeGb
required
The default size of the template in gigabytes.
dtCreated
required
The date the template was created.
dtDeleted
optional Nullable
The date the shared drive was deleted.
id
required
The ID of the template.
name
required
The name of the template.
operatingSystemLabel
required
The operating system installed on the template.
parentMachineId
required
The ID of the parent machine.
region
required
The region the template is in.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"agentType": "string",
"availableMachineTypes": [
{
"isAvailable": true,
"machineTypeLabel": "string"
}
],
"defaultSizeGb": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"id": "string",
"name": "string",
"operatingSystemLabel": "string",
"parentMachineId": "string",
"region": "ny2"
}{
"code": "string",
"message": "string"
}